#!/bin/sh -f

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

flags=
libs=

files=

files="${files} main.cpp moc_MyButton.cpp"

/usr/bin/moc -o moc_MyButton.cpp MyButton.h

# ////////////////////////////////////
# /// Qt /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -F/Library/Frameworks"
else
  flags="${flags} -I/usr/include/qt4"
fi

if [ `uname` = Darwin ] ; then
  libs="${libs} -F/Library/Frameworks -framework QtOpenGL -framework QtGui -framework QtCore"
else
  libs="${libs} -L/usr/lib -lQtOpenGL -lQtGui -lQtCore"
fi

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -DAPPLE_GL -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -framework OpenGL -framework CoreFoundation"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# /// build //////////////////////////
# ////////////////////////////////////

eval c++ ${flags} ${files} ${libs}
