
#include <QtGui/qapplication.h>
#include <QtGui/qpushbutton.h>
#include <QtGui/qboxlayout.h>
#include <QtOpenGL/qgl.h>

#include "MyButton.h"

void MyButton::exitLoop(){qApp->exit(0);}

void MyOpenGLArea::initialieGL() {
  printf("debug : initializeGL\n");
}
void MyOpenGLArea::resizeGL(int,int){
  printf("debug : resize\n");
}

void MyOpenGLArea::mousePressEvent(QMouseEvent* aEvent) {
}
void MyOpenGLArea::mouseReleaseEvent(QMouseEvent* aEvent) {
}
void MyOpenGLArea::mouseMoveEvent(QMouseEvent* aEvent) {
}

void OpenGL_DrawCube(){
  glLineWidth(4);

  // Front :
  glColor3d(1,0,0);    //red
  glBegin(GL_POLYGON);
  glNormal3d(0,0,1);
  glVertex3d( 0.5,-0.5,0.5);
  glVertex3d( 0.5, 0.5,0.5);
  glVertex3d(-0.5, 0.5,0.5);
  glVertex3d(-0.5,-0.5,0.5);
  glEnd();

  // Back :
  glColor3d(0,1,0);   //green
  glBegin(GL_POLYGON);
  glNormal3d(0,0,-1);
  glVertex3d( 0.5,-0.5,-0.5);
  glVertex3d(-0.5,-0.5,-0.5);
  glVertex3d(-0.5, 0.5,-0.5);
  glVertex3d( 0.5, 0.5,-0.5);
  glEnd();

  glColor3d(1,1,0);   //yellow
  glBegin(GL_LINES);
  glVertex3d( 0.5,-0.5, 0.5);
  glVertex3d( 0.5,-0.5,-0.5);
  glVertex3d( 0.5, 0.5, 0.5);
  glVertex3d( 0.5, 0.5,-0.5);
  glVertex3d(-0.5, 0.5, 0.5);
  glVertex3d(-0.5, 0.5,-0.5);
  glVertex3d(-0.5,-0.5, 0.5);
  glVertex3d(-0.5,-0.5,-0.5);
  glEnd();
}

void MyOpenGLArea::paintGL() {

  printf("debug : paintGL %d %d\n",width(),height());

  GLint viewport[4];
  double aspect;

  glEnable(GL_DEPTH_TEST);
  //glEnable(GL_SCISSOR_TEST);

  glEnable(GL_LINE_STIPPLE);
  glPolygonMode(GL_FRONT,GL_FILL);
  //  So that lightning is correctly computed 
  // when some scaling is applied.
  glEnable(GL_NORMALIZE);

  glShadeModel(GL_FLAT);
  //glEnable(GL_LIGHTING);
  //glDisable(GL_LIGHT0);

  glViewport(0,0,width(),height());
  //glScissor(0,0,width,height);

  // In OpenGL, by default,
  // camera is placed at origin, looking at -z, up along y.
  glGetIntegerv(GL_VIEWPORT,viewport);
  aspect = ((double)viewport[2])/((double)viewport[3]);
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();
  // height 2.
  glOrtho(-aspect,aspect,-1,1,-100,100);

  // Better to clear after glViewport and glScissor (else problems with Mesa).
  glClearColor(0.8F,0.8F,0.8F,0);
  glClear(GL_COLOR_BUFFER_BIT);
  glClear(GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  //glScaled(1,1,1);
  // Rotate then translate :
  glTranslated(0,0,-10);
  glRotated(30,0,1,0);
  glRotated(30,1,0,0);

  OpenGL_DrawCube();

  glFinish();
}

int main(int argc,char** argv) {

  QApplication* qapp = new QApplication(argc,argv);

  QWidget* top = new QWidget();
  top->setGeometry(50,50,400,400);

  MyOpenGLArea* gl = new MyOpenGLArea();

  QVBoxLayout* layout = new QVBoxLayout;
  MyButton* button = new MyButton();
  QObject::connect(button,SIGNAL(clicked()),button,SLOT(exitLoop()));
  layout->addWidget(gl);
  layout->addWidget(button);
  top->setLayout(layout);

  top->show();

  qapp->exec();

  delete gl;
  delete top;

  delete qapp;

  printf("debug : exit...\n");

  return 0;
}

