#!/bin/sh -f

if [ "${OSC_HOME_DIR}" = "" ] ; then
  echo "You have to 'source setup' an osc_iv or osc_vis kit."
  exit
fi

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

coingl=${OSC_HOME_DIR}/Resources/CoinGL
coinqt=${OSC_HOME_DIR}/Resources/CoinQt

flags=
libs=

files=

files="${files} main.cpp"

# ////////////////////////////////////
# /// Inventor ///////////////////////
# ////////////////////////////////////
flags="${flags} -I${coingl}/include -I${coinqt}/include"
libs="${libs} -L${OSC_HOME_DIR}/lib -lCoinQt -losc_Coin"

# ////////////////////////////////////
# /// Qt /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -F/Library/Frameworks"
else
  flags="${flags} -I/usr/include/qt4"
fi

if [ `uname` = Darwin ] ; then
  libs="${libs} -F/Library/Frameworks -framework QtOpenGL -framework QtGui -framework QtCore"
else
  libs="${libs} -L/usr/lib -lQtOpenGL -lQtGui -lQtCore"
fi

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -DAPPLE_GL -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -framework OpenGL -framework CoreFoundation"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# ////////////////////////////////////
# ////////////////////////////////////

eval c++ ${flags} ${files} ${libs}
