#!/bin/sh -f

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

flags=
libs=

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -lGL -framework OpenGL -framework AGL"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# /// X11 ////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/lib -lX11"
else
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/${lib} -lX11"
fi

# ////////////////////////////////////
# /// build //////////////////////////
# ////////////////////////////////////

eval cc ${flags} main.c ${libs}
