#!/bin/sh -f

#set -x

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

flags=
libs=

compiler=cc

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -lGL -framework OpenGL -framework AGL"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# /// X11 ////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/lib -lX11"
else
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/${lib} -lX11"
fi

# ////////////////////////////////////
# /// build //////////////////////////
# ////////////////////////////////////

if [ `uname` = Darwin ] ; then
  eval ${compiler} ${flags} -c -o lib.o lib.c
  ${compiler} -dynamiclib -twolevel_namespace -undefined dynamic_lookup -dynamic -single_module -o liblib.dylib lib.o
  libs="./liblib.dylib ${libs}"
else
  eval ${compiler} ${flags} -fPIC -c -o lib.o lib.c
  ${compiler} -shared -o liblib.so lib.o
  libs="./liblib.so ${libs}"
fi

eval ${compiler} ${flags} main.c ${libs}

if [ `uname` = Darwin ] ; then
  dummy=xxx
else
  # ubuntu-11.10 needs the link flag :
  flags="${flags} -Wl,--no-as-needed"
fi

eval ${compiler} ${flags} -o main2 main2.c ${libs}
