#!/bin/sh -f

if [ "${OSC_HOME_DIR}" = "" ] ; then
  echo "You have to 'source setup' an osc_iv or osc_vis kit."
  exit
fi

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

coingl=${OSC_HOME_DIR}/Resources/CoinGL
coinxt=${OSC_HOME_DIR}/Resources/CoinXt

flags=
libs=

# ////////////////////////////////////
# /// Inventor ///////////////////////
# ////////////////////////////////////

flags="${flags} -I${coingl}/include -I${coinxt}/include"
libs="${libs} -L${OSC_HOME_DIR}/lib -lCoinXt -losc_Coin"

# ////////////////////////////////////
# /// OpenGL /////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/System/Library/Frameworks/OpenGL.framework/Headers"
  flags="${flags} -DAPPLE_GL"
  libs="${libs} -framework OpenGL -framework AGL"
  libs="${libs} -framework ApplicationServices"
  libs="${libs}  /usr/X11R6/lib/libGLU.dylib /usr/X11R6/lib/libGL.dylib -lobjc"
fi

# ////////////////////////////////////
# /// Xm /////////////////////////////
# ////////////////////////////////////

if [ `uname` = Darwin ] ; then
  libs="${libs} -L/opt/local/lib -lXm -lXmu -lXt"
else
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
  libs="${libs} -lXm"
fi

# ////////////////////////////////////
# /// X11 ////////////////////////////
# ////////////////////////////////////
flags="${flags} -I/usr/X11R6/include"
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/opt/local/include"
fi
libs="${libs} -L/usr/X11R6/${lib} -lXi -lXext -lXpm -lX11"

# ////////////////////////////////////
# ////////////////////////////////////
# ////////////////////////////////////

c++ -o cube.exe ${flags} main.cpp ${libs}
c++ -o cube_2D.exe ${flags} main_2D.cpp ${libs}

# ////////////////////////////////////
# ////////////////////////////////////
# ////////////////////////////////////

libs="${libs} -L${OSC_HOME_DIR}/lib -lHEPVisDetector -lHEPVisGeometry -lHEPVisUtils -losc_dvi2bitmap -losc_png -losc_freetype2 -losc_jpeg -losc_zlib"

eval c++ -o read.exe ${flags} main_read.cpp ${libs}


