#include <stdio.h>
#include <stdlib.h>

#include <X11/StringDefs.h>

#include <Xm/Form.h>

#include <Xm/PushB.h>

static void ButtonCallback(Widget w,XtPointer a_data,XtPointer p){
  exit(0);
}

#if defined(__APPLE__) && (XmVERSION>=2) && (XmREVISION>=3)
#include <Xm/Display.h>
#include <Xm/DialogS.h>
#include <Xm/DragOverS.h>
#include <Xm/GrabShell.h>
#include <Xm/Print.h>
#include <X11/IntrinsicP.h>

static void ResetVendorField(WidgetClass aWidgetClass){
  WidgetClass wc = aWidgetClass;
  while(wc) {
    WidgetClass super = wc->core_class.superclass;
    if(super) {
      char* name = (char*)super->core_class.class_name;
      if( !strcmp(name,"VendorShell") && (super!=vendorShellWidgetClass) ) {
        /* The Vendor super class is not the Motif one, override : */
        wc->core_class.superclass = vendorShellWidgetClass;
        return;
      }
    }
    wc = super;
  }
}

static void LookDSM_Problem(){
  if(!vendorShellWidgetClass->core_class.class_part_initialize) {
    /* The vendorShellWidgetClass we get is the Xt one. */
    printf("\
OnX::XtUI::LookDSM_Problem :\n\
 Can't solve the dsm problem.\n\
 Bad linking order of -lXm and -lXt\n\
 or you try to load a DLL linked to X11 prior to\n\
 load a DLL linked with Motif.\n\
");
    return;
  }
  ResetVendorField(xmDisplayClass);
  ResetVendorField(xmDialogShellWidgetClass);
  ResetVendorField(xmDragOverShellWidgetClass);
  ResetVendorField(xmGrabShellWidgetClass);
  ResetVendorField(xmPrintShellWidgetClass);
}
#else
static void LookDSM_Problem(){}
#endif

/* #include <Xm/MwmUtil.h> */

int main(int a_argn,char* a_args[]){
  /* printf("debug : main : 0\n"); */
#if XtSpecificationRelease == 4
  Cardinal argn = (Cardinal)a_argn;
#else
  int argn = a_argn;
#endif
  XtAppContext appContext = NULL;
  Arg args[7];
  Widget top,dform,button;

  LookDSM_Problem();

  /*
  unsigned long Mwm_decor = 0;
  unsigned long Mwm_funct = 0;
  Mwm_funct |= MWM_FUNC_CLOSE;
  Mwm_funct |= MWM_FUNC_MINIMIZE;
  Mwm_decor |= MWM_DECOR_MINIMIZE;
  Mwm_funct |= MWM_FUNC_MAXIMIZE;
  Mwm_decor |= MWM_DECOR_MAXIMIZE;
  Mwm_decor |= MWM_DECOR_RESIZEH;
  Mwm_funct |= MWM_FUNC_RESIZE;
  Mwm_decor |= MWM_DECOR_BORDER;
  Mwm_funct |= MWM_FUNC_MOVE;
  Mwm_decor |= MWM_DECOR_TITLE;
  Mwm_decor |= MWM_DECOR_MENU;
  */
  XtSetArg(args[0],XtNgeometry,XtNewString("200x200"));
  XtSetArg(args[1],XtNborderWidth,0);
  /*
  XtSetArg(args[2],XmNmwmDecorations,Mwm_decor);
  XtSetArg(args[3],XmNmwmFunctions,Mwm_funct);
  */
  top = XtAppInitialize(&appContext,"test",
                               NULL,(Cardinal)0,
                               &argn,a_args,NULL,
                               args,2);

  dform = XmCreateForm(top,(char*)"dform",NULL,0);
  XtManageChild(dform);

  XtSetArg(args[0],XmNtopAttachment   ,XmATTACH_FORM);
  XtSetArg(args[1],XmNleftAttachment  ,XmATTACH_FORM);
  XtSetArg(args[2],XmNrightAttachment ,XmATTACH_FORM);
  XtSetArg(args[3],XmNbottomAttachment ,XmATTACH_FORM);
  button = XmCreatePushButton(dform,(char*)"Quit",args,4);
  XtManageChild(button);
  XtAddCallback(button,XmNactivateCallback,ButtonCallback,(XtPointer)top);

  XtRealizeWidget(top);

  XtAppMainLoop(appContext);

  return EXIT_SUCCESS;
}
