#!/bin/sh -f

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

files=
flags=
libs=

files="${files} main.c"
files="${files} OpenGLArea.c"

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -lGL -framework OpenGL -framework AGL"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# /// Xt + X11 ///////////////////////
# ////////////////////////////////////
flags="${flags} -I/usr/X11R6/include"

if [ `uname` = Darwin ] ; then
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/lib -lXt -lX11"
else
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/${lib} -lXt -lX11"
fi

# ////////////////////////////////////
# /// build //////////////////////////
# ////////////////////////////////////

eval cc ${flags} ${files} ${libs}
