#include <stdio.h>
#include <stdlib.h>

#include <X11/StringDefs.h>

#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include "OpenGLArea.h"

#include <GL/gl.h>

static void ButtonCallback(Widget w,XtPointer p,XtPointer p1){
  exit(0);
}

static void paint_cbk(Widget w,XtPointer p,XtPointer p1);
static void DrawCube();

int main(int a_argn,char* a_args[]){
  //printf("debug : main : 0\n");
#if XtSpecificationRelease == 4
  Cardinal argn = (Cardinal)a_argn;
#else
  int argn = a_argn;
#endif
  XtAppContext appContext = NULL;
  Arg args[7];
  Widget top;

  XtSetArg(args[0],XtNgeometry,XtNewString("200x200"));
  XtSetArg(args[1],XtNborderWidth,0);
  top = XtAppInitialize(&appContext,"test",
                               NULL,(Cardinal)0,
                               &argn,a_args,NULL,
                               args,2);

 {Widget glArea = XtCreateManagedWidget
    ("gl",openGLAreaWidgetClass,top,args,0);
  XtAddCallback(glArea,XoNpaintCallback,paint_cbk,(XtPointer)0);}


  XtRealizeWidget(top);

  XtAppMainLoop(appContext);

  return EXIT_SUCCESS;
}

static void DrawCube() {
  glLineWidth(4);

  // Front :
  glColor3d(1,0,0);    //red
  glBegin(GL_POLYGON);
  glNormal3d(0,0,1);
  glVertex3d( 0.5,-0.5,0.5);
  glVertex3d( 0.5, 0.5,0.5);
  glVertex3d(-0.5, 0.5,0.5);
  glVertex3d(-0.5,-0.5,0.5);
  glEnd();

  // Back :
  glColor3d(0,1,0);   //green
  glBegin(GL_POLYGON);
  glNormal3d(0,0,-1);
  glVertex3d( 0.5,-0.5,-0.5);
  glVertex3d(-0.5,-0.5,-0.5);
  glVertex3d(-0.5, 0.5,-0.5);
  glVertex3d( 0.5, 0.5,-0.5);
  glEnd();

  glColor3d(1,1,0);   //yellow
  glBegin(GL_LINES);
  glVertex3d( 0.5,-0.5, 0.5);
  glVertex3d( 0.5,-0.5,-0.5);
  glVertex3d( 0.5, 0.5, 0.5);
  glVertex3d( 0.5, 0.5,-0.5);
  glVertex3d(-0.5, 0.5, 0.5);
  glVertex3d(-0.5, 0.5,-0.5);
  glVertex3d(-0.5,-0.5, 0.5);
  glVertex3d(-0.5,-0.5,-0.5);
  glEnd();
}

#include <X11/IntrinsicP.h>

static void paint_cbk(Widget a_widget,XtPointer p,XtPointer p1){
  unsigned int width,height;
  GLint viewport[4];
  double aspect;
  double half_height = 1;

  //printf("debug : paint_cbk\n");
  width = a_widget->core.width;
  height = a_widget->core.height;

  glEnable(GL_DEPTH_TEST);
  //glEnable(GL_SCISSOR_TEST);

  glEnable(GL_LINE_STIPPLE);
  glPolygonMode(GL_FRONT,GL_FILL);
  //  So that lightning is correctly computed 
  // when some scaling is applied.
  glEnable(GL_NORMALIZE);

  glShadeModel(GL_FLAT);
  //glEnable(GL_LIGHTING);
  //glDisable(GL_LIGHT0);

  glViewport(0,0,width,height);
  //glScissor(0,0,width,height);

  // In OpenGL, by default,
  // camera is placed at origin, looking at -z, up along y.
  glGetIntegerv(GL_VIEWPORT,viewport);
  aspect = ((double)viewport[2])/((double)viewport[3]);
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();

  glOrtho(-aspect * half_height,aspect*half_height,
          -half_height,half_height,-100,100);

  // Better to clear after glViewport and glScissor (else problems with Mesa).
  glClearColor(0.8F,0.8F,0.8F,0);
  glClear(GL_COLOR_BUFFER_BIT);
  glClear(GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  //glScaled(1,1,1);
  // Rotate then translate :
  glTranslated(0,0,-10);
  glRotated(30,0,1,0);
  glRotated(30,1,0,0);

  DrawCube();

  glFinish();
}
