#!/bin/sh -f

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

files=
flags=
libs=

files="${files} main.c"

# ////////////////////////////////////
# /// gtk ////////////////////////////
# ////////////////////////////////////
flags="${flags} `pkg-config --cflags gtk+-2.0`"
libs="${libs} `pkg-config --libs gtk+-2.0`"

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -lGL -framework OpenGL -framework AGL"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# /// X11 ////////////////////////////
# ////////////////////////////////////
flags="${flags} -I/usr/X11R6/include"

if [ `uname` = Darwin ] ; then
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/lib -lX11"
else
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/${lib} -lX11"
fi

# ////////////////////////////////////
# /// gtkglarea //////////////////////
# ////////////////////////////////////
# we take the source code from osc_vis/gtkglarea.

dir_glarea="../gtkglarea"
files="${files} ${dir_glarea}/source/gtkglarea.c ${dir_glarea}/source/gdkgl.c"

flags="${flags} -I${dir_glarea}/include"
flags="${flags} -I${dir_glarea}/include/gtkgl"

# ////////////////////////////////////
# /// build //////////////////////////
# ////////////////////////////////////

eval cc ${flags} ${files} ${libs}
