#!/bin/sh -f

if [ "${OSC_HOME_DIR}" = "" ] ; then
  echo "You have to 'source setup' an osc_iv or osc_vis kit."
  exit
fi

if [ `uname` = Darwin ] ; then
  lib=lib
else
  if [ `uname -p` = x86_64 ] ; then
    lib=lib64
  else
    lib=lib
  fi
fi

coingl=${OSC_HOME_DIR}/Resources/CoinGL
coingtk=${OSC_HOME_DIR}/Resources/CoinGtk

flags=
libs=

# ////////////////////////////////////
# /// Inventor ///////////////////////
# ////////////////////////////////////

flags="${flags} -I${coingl}/include -I${coingtk}/include"
libs="${libs} -L${OSC_HOME_DIR}/lib -lCoinGtk -losc_gtkglarea -losc_Coin"

# ////////////////////////////////////
# /// gtk ////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/opt/local/${lib}/glib-2.0/include -I/opt/local/include/glib-2.0 -I/opt/local/include/gtk-2.0  -I/opt/local/${lib}/gtk-2.0/include -I/opt/local/include/atk-1.0 -I/opt/local/include/pango-1.0 -I/opt/local/include/cairo"
else
  flags="${flags} -I/usr/${lib}/glib-2.0/include -I/usr/include/glib-2.0 -I/usr/include/gtk-2.0  -I/usr/${lib}/gtk-2.0/include -I/usr/include/atk-1.0 -I/usr/include/pango-1.0 -I/usr/include/cairo"
fi

if [ `uname` = Darwin ] ; then
  libs="${libs} -L/opt/local/${lib} -lgtk-x11-2.0 -lgdk-x11-2.0 -lgobject-2.0 -lglib-2.0"
else
  libs="${libs} -L/usr/${lib} -lgtk-x11-2.0 -lgdk-x11-2.0 -lgobject-2.0 -lglib-2.0"
fi

# ////////////////////////////////////
# /// GL /////////////////////////////
# ////////////////////////////////////
if [ `uname` = Darwin ] ; then
  flags="${flags} -I/System/Library/Frameworks/OpenGL.framework/Headers"
  libs="${libs} -lGL -framework OpenGL -framework AGL"
else
  flags="${flags} -I/usr/include"
  libs="${libs} -L/usr/X11R6/${lib} -lGLU -lGL"
fi

# ////////////////////////////////////
# /// X11 ////////////////////////////
# ////////////////////////////////////
flags="${flags} -I/usr/X11R6/include"

if [ `uname` = Darwin ] ; then
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/lib -lXt -lX11"
else
  flags="${flags} -I/usr/X11R6/include"
  libs="${libs} -L/usr/X11R6/${lib} -lXt -lX11"
fi

# ////////////////////////////////////
# /// gtkglarea //////////////////////
# ////////////////////////////////////
# we take the source code from osc_vis/gtkglarea.

dir_glarea="../gtkglarea"
files="${files} ${dir_glarea}/source/gtkglarea.c ${dir_glarea}/source/gdkgl.c"

flags="${flags} -I${dir_glarea}/include"
flags="${flags} -I${dir_glarea}/include/gtkgl"

# ////////////////////////////////////
# ////////////////////////////////////
# ////////////////////////////////////

eval c++ ${flags} main.cpp ${libs}
